
function max(a, b)
    if a > b then
	return a
    end
    return b
end

function countRoll( n, f )
    local nums = {}
    for i = 1, n do
	local v = nDm( 1, f )
	if nums[v] then
	    nums[v] = 1 + nums[v]
  	else
	    nums[v] = 1
	end
    end
    return nums
end

function countnum( h )
    local ret = 0
    for k,v in pairs( h ) do
	ret = ret + v
    end
    return ret
end

function countsum( h )
    local ret = 0
    for k,v in pairs( h ) do
	ret = ret + k * v
    end
    return ret
end

function zorotasiRoll( n, f, plus )
    local total = 0
    local hash = countRoll( n, f )
    for k,v in pairs( hash ) do
	if v > 1 then
	    total = total + zorotasiRoll( v + plus, f, plus )
	end
	total = total + k * v
    end
    return total
end

function forceZorotasiRoll( n, f, plus )
    if n < 2 then return nDm(1,f) end
    local total = 0
    local hash = countRoll( n, f )
    local existZoro = false
    local min1 = 0
    local min2 = 0
    for k,v in pairs( hash ) do
	if v > 1 then
	    existZoro = true
	    break
	end
	if k < min1 and v > 0 then
	    min2 = min1
	    min1 = k
	end
    end
    if not existZoro then
	if min2 > 0 then
	    hash[min2] = hash[min2] - 1
	    hash[min1] = hash[min1] + 1
	end
    end
    for k,v in pairs( hash ) do
	if v > 1 then
	    total = total + zorotasiRoll( v + plus, f, plus )
	end
	total = total + k * v
    end
    return total
end

function httHyperRoll( n )
    return zorotasiRoll( n, 6, 0 )
end

function httBerserkRoll( n )
    return zorotasiRoll( n, 6, 1 )
end
